import axios from "axios";

type GetParams = {
  params: {
    platform: string
    encodedUrl: string
  };
};

export async function GET(req: Request, { params }: GetParams) {

  const { platform, encodedUrl } = params;

  const decodedUrl = decodeURIComponent(encodedUrl)
  
  const response = await axios.get<ReadableStream>(decodedUrl, {
    responseType: "stream",
  });

  return new Response(response.data);
}

