import { PORNHUB_BASE_URL, PORNHUB_BASE_URL_VIDEO } from "@/constants/urls";
import { FetchParams, GalleryData, VideoData } from "@/meta/data";
import { getHeaders, getHeadersWithCookie } from "../common/headers";
import { getDataFromRedis, storeDataIntoRedis } from "@/redis/client";
import { DEFAULT_PORNHUB_VIDEO_EXPIRY, DEFAULT_RELATED_VIDEO_KEY_PATH } from "@/constants/redis";

import * as cheerio from "cheerio";

import axios, { AxiosError } from "axios";
import { createSessionCookie, findGetMediaUrlInTagblock } from "../common/mindgeek";

export const fetchPornHubVideoData = async (videoId: string, params?: FetchParams): Promise<[VideoData, GalleryData[]]> => {

    let data: VideoData = {
        lowResUrl: ''
    }

    let related: GalleryData[] = [];

    let reqHeaders = getHeaders(PORNHUB_BASE_URL)

    const queryUrl = `${PORNHUB_BASE_URL_VIDEO}${videoId.replace(/\//g, '')}`

    const cachedVideoData = await getDataFromRedis(queryUrl)
    const cachedRelatedData = await getDataFromRedis(queryUrl + DEFAULT_RELATED_VIDEO_KEY_PATH)

    if (cachedVideoData) {
        return [cachedVideoData as VideoData, cachedRelatedData as GalleryData[] ?? []]
    }

    await axios.get(queryUrl, reqHeaders)   

        .then(async response => {

            const sessionCookie = response?.headers["set-cookie"] ? createSessionCookie(response?.headers["set-cookie"]) : '';

            const html = response.data;

            const $ = cheerio.load(html);

            const scriptTags = $("script");

            // populate video data object
            scriptTags.map(async (idx, elem) => {
                const getMediaUrl = findGetMediaUrlInTagblock($(elem).toString())

                if (getMediaUrl) {

                    const headersWithCookie = getHeadersWithCookie(PORNHUB_BASE_URL, sessionCookie)

                    await axios.get(getMediaUrl, headersWithCookie)

                        .then(response => {

                            console.log(response.data)
            
                            // magic goes here

                        })

                        .catch(error => console.log(error))
                }


            })

            await storeDataIntoRedis(queryUrl, data, DEFAULT_PORNHUB_VIDEO_EXPIRY);

            // populate related gallery
            scriptTags.map((idx, elem) => {

                // magic goes here

            })

            await storeDataIntoRedis(queryUrl + DEFAULT_RELATED_VIDEO_KEY_PATH, related, DEFAULT_PORNHUB_VIDEO_EXPIRY);

        }).catch((error: AxiosError) => {
            console.log(queryUrl)
            console.log(error.message)
        });

    return [ { lowResUrl: 'https://www.w3schools.com/html/mov_bbb.mp4' } ,[]]
}